module Hermes
  module Concerns
    module ChangeMinusTwoYearConcern
      extend ActiveSupport::Concern

      module ClassMethods
        def get_rfr_settings
          return unless config_values = Setting.find_by(key: 'hermes_rfr_settings')&.values

          change_minus_two_date = config_values['change_minus_two_date']&.to_date || Date.today
          message_duration = config_values['message_duration']&.to_i || 0
          should_show_rfr_message = config_values['should_show_rfr_message'] || false
          show_warning_message = should_show_rfr_message && change_minus_two_date + message_duration.days > Date.today

          config_values.merge(show_warning_message: show_warning_message)
        end 
      end

      included do
        extend ClassMethods

        def get_minus_two_year
          default_year = Date.today.year - 2 
          config_values = self.class.get_rfr_settings
          return default_year unless config_values

          change_minus_two_date = config_values['change_minus_two_date']&.to_date
          change_minus_two_year = config_values['change_minus_two_year']&.to_i

          return default_year unless change_minus_two_year && change_minus_two_date

          Date.today >= change_minus_two_date ? change_minus_two_year : change_minus_two_year - 1
        end
      end
    end
  end
end