# frozen_string_literal: true

module Hermes
  module BoClient
    class CancelStatusTask < BaseTask
      
      def initialize(options = {})
        @xsd = 'AnnulationCandidature.xsd'
        super(options)
      end
      
      endpoint {'/ws/rest/als/demande/v1/annulerCandidature'}
      
      task_name 'cancelstatus'
      type_flux 'BIEN'
      mapping 'Hermes::BoClient::Mappings::HousingApplicationMap'
      
      params *%i[
        refInterneDemande
        refInterneOffre
        dateAnnulation
      ]
      
      def to_xml
        namespaces = {
            'xmlns:ns2' => 'http://v1.als.ikos.webservice.immobilier.sopra/demande/annulerCandidature'
        }
        builder = Nokogiri::XML::Builder.new(encoding: 'UTF-8') do |b|
          b[:ns2].annulerCandidature(namespaces) do
            
            b.refInterneDemande mapping.refInterneDemande do
              b.parent.namespace = nil
            end
            b.refInterneOffre mapping.refInterneOffre do
              b.parent.namespace = nil
            end
		        b.dateAnnulation mapping.status_updated_at do
              b.parent.namespace = nil
            end
          end
         
        end
        builder.to_xml
      end
    end
  end
end
