
module Hermes
  module BoClient
    class EntityRequestTask < BaseTask
      
      def initialize(options = {})
        @xsd = "entrepriseDemande.xsd"
        super(options)
      end
      
      endpoint {'/ws/rest/als/demande/v1/entreprise'}
      
      task_name 'EntityRequest'
      type_flux 'BIEN'
      mapping 'Hermes::BoClient::Mappings::HousingRequestMap'
      
      params *%i[
        refInterneDemande
        refInterneOffre
      ]
      
      def to_xml
        namespaces = {
          'xmlns:ns2' => 'http://v1.als.ikos.webservice.immobilier.sopra/demande/entrepriseDemande'
        }
        
        builder = Nokogiri::XML::Builder.new(encoding: 'UTF-8') do |b|
          b['ns2'].entrepriseDemande(namespaces) do
            b.numUnique mapping.numUnique do
              b.parent.namespace = nil
            end
            b.refInterneDemande mapping.refInterne do
              b.parent.namespace = nil
            end
		        b.idREX mapping.idREX do
              b.parent.namespace = nil
            end
            b.appCommerciale mapping.appCommerciale do
              b.parent.namespace = nil
            end
            b.numSiret mapping.numSiret do
              b.parent.namespace = nil
            end
          end
        end
        
        builder.to_xml
      end
    end
  end
end
