require 'rails_helper'

describe Api::D1::GroupsController, type: :api do
  include Devise::Test::ControllerHelpers
  let!(:admin) { FactoryBot.create(:administrator) }
  let!(:group) { FactoryBot.create(:group) }

  describe 'all routes disabled' do
    before(:each) do
      authenticated_header(request, admin)
    end 

    it 'index' do
      get 'index'
      expect(response).to have_http_status(401)
    end

    it 'users' do 
      get 'users', id: group.id
      expect(response).to have_http_status(401)
    end

    it 'show' do 
      get 'show', id: group.id
      expect(response).to have_http_status(401)
    end

    it 'create' do 
      get 'create'
      expect(response).to have_http_status(401)
    end

    it 'update' do 
      get 'update', id: group.id
      expect(response).to have_http_status(401)
    end

    it 'destroy' do 
      get 'destroy', id: group.id
      expect(response).to have_http_status(401)
    end

  end

end 
